#ifndef mlib_H_
#define mlib_H_
#include "X2C.h"

typedef X2C_CARD8 cc_t;

typedef X2C_CARD32 speed_t;

typedef X2C_CARD32 tcflag_t;

struct termios;


struct termios {
   X2C_CARD32 c_iflag;
   X2C_CARD32 c_oflag;
   X2C_CARD32 c_cflag;
   X2C_CARD32 c_lflag;
   X2C_CARD8 c_line;
   X2C_CARD8 c_cc[32];
   X2C_CARD32 c_ispeed;
   X2C_CARD32 c_ospeed;
};

typedef X2C_CHAR * tExecArg[256];

extern X2C_INT32 B0;

extern X2C_INT32 B50;

extern X2C_INT32 B75;

extern X2C_INT32 B110;

extern X2C_INT32 B134;

extern X2C_INT32 B150;

extern X2C_INT32 B200;

extern X2C_INT32 B300;

extern X2C_INT32 B600;

extern X2C_INT32 B1200;

extern X2C_INT32 B1800;

extern X2C_INT32 B2400;

extern X2C_INT32 B4800;

extern X2C_INT32 B9600;

extern X2C_INT32 B19200;

extern X2C_INT32 B38400;

extern X2C_INT32 BRKINT;

extern X2C_INT32 CLOCAL;

extern X2C_INT32 CREAD;

extern X2C_INT32 CS5;

extern X2C_INT32 CS6;

extern X2C_INT32 CS7;

extern X2C_INT32 CS8;

extern X2C_INT32 CSIZE;

extern X2C_INT32 CSTOPB;

extern X2C_INT32 ECHO;

extern X2C_INT32 ECHOE;

extern X2C_INT32 ECHOK;

extern X2C_INT32 ECHONL;

extern X2C_INT32 HUPCL;

extern X2C_INT32 ICANON;

extern X2C_INT32 ICRNL;

extern X2C_INT32 IEXTEN;

extern X2C_INT32 IGNBRK;

extern X2C_INT32 IGNCR;

extern X2C_INT32 IGNPAR;

extern X2C_INT32 IGNLCR;

extern X2C_INT32 INPCK;

extern X2C_INT32 ISIG;

extern X2C_INT32 ISTRIP;

extern X2C_INT32 IXOFF;

extern X2C_INT32 IXON;

extern X2C_INT32 NCCS;

extern X2C_INT32 NOFLASH;

extern X2C_INT32 OPOST;

extern X2C_INT32 PARENB;

extern X2C_INT32 PARMRK;

extern X2C_INT32 PARODD;

extern X2C_INT32 TOSTOP;

extern X2C_INT32 VEOF;

extern X2C_INT32 VEOL;

extern X2C_INT32 VERASE;

extern X2C_INT32 VINTR;

extern X2C_INT32 VKILL;

extern X2C_INT32 VMIN;

extern X2C_INT32 VQUIT;

extern X2C_INT32 VSTART;

extern X2C_INT32 VSTOP;

extern X2C_INT32 VSUSP;

extern X2C_INT32 VTIME;

#define TIOCMBIS 0x5416 

#define TIOCMBIC 0x5417 

#define TIOCMSET 0x5418 

#define TIOCMGET 0x5415 

#define TIOCMIWAIT 0x545C 

#define TIOCM_LE 0x1 

#define TIOCM_DTR 0x2 

#define TIOCM_RTS 0x4 

#define TIOCM_ST 0x8 

#define TIOCM_SR 0x10 

#define TIOCM_CTS 0x20 

#define TIOCM_CAR 0x40 

#define TIOCM_RNG 0x80 

#define TIOCM_DSR 0x100 

#define TIOCM_CD 64

#define TIOCM_RI 128

#define TIOCM_OUT1 0x2000 

#define TIOCM_OUT2 0x4000 

#define TCOOFF 0

#define TCOON 1

#define TCIOFF 2

#define TCION 3

#define TCIFLUSH 0

#define TCOFLUSH 1

#define TCIOFLUSH 2

#define TCSANOW 0

#define TCSADRAIN 1

#define TCSAFLUSH 2

extern X2C_CARD32 cfgetispeed(struct termios *);

extern X2C_CARD32 cfgetospeed(struct termios *);

extern X2C_INT32 cfsetispeed(struct termios *, X2C_CARD32);

extern X2C_INT32 cfsetospeed(struct termios *, X2C_CARD32);

extern X2C_INT32 tcdrain(X2C_INT32);

extern X2C_INT32 tcflow(X2C_INT32, X2C_INT32);

extern X2C_INT32 tcflush(X2C_INT32, X2C_INT32);

extern X2C_INT32 tcgetattr(X2C_INT32, struct termios *);

extern X2C_INT32 tcdsendbreak(X2C_INT32, X2C_INT32);

extern X2C_INT32 tcsetattr(X2C_INT32, X2C_INT32, struct termios *);

extern X2C_INT32 ioctl(X2C_INT32, X2C_INT32, X2C_ADDRESS);


#endif /* mlib_H_ */
