IMPLEMENTATION MODULE FIO;

FROM SYSTEM IMPORT BYTE, ADR;
FROM types IMPORT off_t;
FROM unistd IMPORT close, lseek, SEEK_SET, SEEK_CUR, SEEK_END;
FROM fcntl IMPORT open, O_RDWR, O_NONBLOCK, F_SETFL, fcntl;

PROCEDURE Create(name:ARRAY OF CHAR):File;
BEGIN RETURN creat(name, 644B) END Create;

PROCEDURE OpenMode(name:ARRAY OF CHAR; mode:INTEGER):File;
BEGIN
  IF (name[0] = '-') AND ((HIGH(name) = 0) OR (name[1] = CHR(0))) THEN RETURN 0 END;
  RETURN open(name, mode)
END OpenMode;

PROCEDURE Open(name:ARRAY OF CHAR):File;
BEGIN
  RETURN OpenMode(name, O_RDWR)
END Open;

PROCEDURE IsOpen(VAR fd: File; name:ARRAY OF CHAR):BOOLEAN;
BEGIN
  fd:=Open(name);
  RETURN fd>=0
END IsOpen;

PROCEDURE Seek(fd: File; pos: CARDINAL);
VAR res: off_t;
BEGIN res:=lseek(fd, VAL(off_t, pos), SEEK_SET) END Seek;

PROCEDURE GetPos(fd: File): CARDINAL;   
BEGIN RETURN VAL(CARDINAL, lseek(fd, 0, SEEK_CUR)) END GetPos;

PROCEDURE Size(fd: File): CARDINAL;  
VAR res: off_t;
    pos: CARDINAL;
BEGIN 
  pos:=GetPos(fd);
  res:=lseek(fd, 0, SEEK_END);
  Seek(fd, pos);
  RETURN VAL(off_t, res)
END Size;

PROCEDURE Append(name:ARRAY OF CHAR):File;
VAR fd:File;
BEGIN
  fd:=Open(name);
  IF fd>=3 THEN Seek(fd, Size(fd)) END;                                    
  RETURN fd                                                                   
END Append;                                                                     

PROCEDURE Close(fd: File);
VAR res:INTEGER;
BEGIN 
  res:=close(fd);
END Close;

PROCEDURE RdBin(fd: File; VAR buf:ARRAY OF BYTE; size:CARDINAL):INTEGER;   
BEGIN
  IF size>HIGH(buf)+1 THEN size:=HIGH(buf)+1 END;
  RETURN read(fd, ADR(buf), size)
END RdBin;

PROCEDURE RdChar(fd:File):CHAR;
VAR c:CHAR;
BEGIN
  IF read(fd, ADR(c), 1)=1 THEN RETURN c END;
  RETURN 0C
END RdChar;

PROCEDURE RdItem(fd:File; VAR buf:ARRAY OF BYTE);
VAR res:INTEGER;
BEGIN
  res:=read(fd, ADR(buf), HIGH(buf)+1);
END RdItem;

PROCEDURE WrChar(fd:File; ch:CHAR);
VAR res:INTEGER;
BEGIN
  res:=write(fd, ADR(ch), 1);
END WrChar;

PROCEDURE WrBin(fd:File; VAR buf:ARRAY OF BYTE; size:CARDINAL);
VAR res:INTEGER;
BEGIN
  IF size>HIGH(buf)+1 THEN size:=HIGH(buf)+1 END;
  res:=write(fd, ADR(buf), size);
END WrBin;

PROCEDURE Write(fd:File; VAR buf:ARRAY OF BYTE; size:CARDINAL):INTEGER;
BEGIN
  IF size>HIGH(buf)+1 THEN size:=HIGH(buf)+1 END;
  RETURN write(fd, ADR(buf), size)
END Write;

PROCEDURE WrItem(fd:File; VAR buf:ARRAY OF BYTE);
VAR res:INTEGER;
BEGIN
  res:=write(fd, ADR(buf), HIGH(buf)+1);
END WrItem;

PROCEDURE SetRdBlock(fd:File);      (*switch to blocking read fd=0 stdin*)
VAR res:INTEGER;
BEGIN
  res:=fcntl(fd, F_SETFL, 0000B);
END SetRdBlock;

PROCEDURE SetRdNonBlock(fd:File);   (*switch to blocking read, fd=0 stdin*)
VAR res:INTEGER;
BEGIN
  res:=fcntl(fd, F_SETFL, O_NONBLOCK);
END SetRdNonBlock;

PROCEDURE AppExt(VAR fn:ARRAY OF CHAR; ext:ARRAY OF CHAR; delext:BOOLEAN);
VAR i,j:CARDINAL;
BEGIN
  j:=0;
  i:=0;
  WHILE (j<HIGH(fn)) & (fn[j]#0C) DO
    IF fn[j]="/" THEN i:=j END;
    INC(j);
  END;
  LOOP
    IF (i>HIGH(fn)) OR (fn[i]=0C) THEN EXIT END;
    IF fn[i]="." THEN
      IF delext THEN EXIT ELSE RETURN END;
    END;
    INC(i);
  END;
  j:=0;
  WHILE (i<=HIGH(fn)) & (j<=HIGH(ext)) & (ext[j]#0C) DO
    fn[i]:=ext[j];
    INC(i);
    INC(j);
  END;
  IF i<=HIGH(fn) THEN fn[i]:=0C END;
END AppExt;

END FIO.
