IMPLEMENTATION MODULE Str;

IMPORT Strings;

PROCEDURE Assign (VAR dest: ARRAY OF CHAR; src: ARRAY OF CHAR);
BEGIN Strings.Assign(src, dest) END Assign;

PROCEDURE Append (VAR dest: ARRAY OF CHAR; suffix: ARRAY OF CHAR);
BEGIN Strings.Append(suffix, dest) END Append;

PROCEDURE Pos (str: ARRAY OF CHAR; substr: ARRAY OF CHAR): INTEGER;
VAR ok: BOOLEAN;
    p : CARDINAL;
BEGIN 
  Strings.FindNext(substr, str, 0, ok, p);
  IF ok THEN RETURN p END;
  RETURN -1
END Pos;

PROCEDURE Copy(VAR dest: ARRAY OF CHAR; inx, len: CARDINAL; str: ARRAY OF CHAR);
BEGIN Strings.Extract (str, inx, len, dest) END Copy;

PROCEDURE Concat(VAR dest: ARRAY OF CHAR; s1, s2: ARRAY OF CHAR);
BEGIN Strings.Concat (s1, s2, dest) END Concat;

PROCEDURE Insert(VAR dest: ARRAY OF CHAR; VAR substr: ARRAY OF CHAR; inx: CARDINAL);
BEGIN Strings.Insert (substr, inx, dest) END Insert;

PROCEDURE ToLeft(VAR s:ARRAY OF CHAR);                                          
VAR i:CARDINAL;                                                                 
BEGIN                                                                           
  i:=0;                                                                         
  WHILE (i<=HIGH(s)) AND (s[i]=" ") DO INC(i) END;                              
  Delete(s,0,i);                                                                
END ToLeft;                                                                     
                                                                                
PROCEDURE ExtractWord(VAR w,s:ARRAY OF CHAR);                                   
VAR i:CARDINAL;                                                                 
BEGIN                                                                           
  w[0]:=0C;                                                                     
  ToLeft(s);                                                                    
  i:=0;                                                                         
  WHILE (s[i]#0C) & (s[i]#" ") DO                                               
    IF i<=HIGH(w) THEN w[i]:=s[i] END;                                          
    INC(i);                                                                     
  END;                                                                          
  Delete(s,0,i);                                                                
  IF i<=HIGH(w) THEN w[i]:=0C END;                                              
END ExtractWord;                                                                

PROCEDURE StrToCard(VAR s: ARRAY OF CHAR; VAR x:CARDINAL) : BOOLEAN;            
VAR i:CARDINAL;                                                                 
    ok:BOOLEAN;                                                                 
BEGIN                                                                           
  x:=0;                                                                         
  ok:=FALSE;                                                                    
  FOR i:=0 TO HIGH(s) DO                                                        
    IF (s[i]>="0") & (s[i]<="9") THEN x:=x*10+(ORD(s[i])-ORD("0")); ok:=TRUE    
    ELSE RETURN ok & (s[i]=0C) END;                                             
  END;                                                                          
  RETURN ok;                                                                    
END StrToCard;                                                                  

PROCEDURE StrToInt(VAR s: ARRAY OF CHAR; VAR x:INTEGER) : BOOLEAN;
VAR i:CARDINAL;
    ok:BOOLEAN;
BEGIN
  x:=0;
  ok:=FALSE;
  i:=0;
  IF s[0]="-" THEN INC(i) END;
  WHILE (i<=HIGH(s)) & (s[i]>="0") & (s[i]<="9") DO 
    x:=x*10+VAL(INTEGER, ORD(s[i])-ORD("0")); 
    ok:=TRUE;
    INC(i); 
  END;
  IF (i>HIGH(s)) OR (s[i]<>0C) THEN ok:=FALSE END;
  IF s[0]="-" THEN x:=-x END;
  RETURN ok
END StrToInt;




PROCEDURE StrToBased(VAR s:ARRAY OF CHAR; Base:CARDINAL; VAR x:INTEGER):BOOLEAN;
VAR i:CARDINAL;                                                                 
    sign,ok:BOOLEAN;                                                            
BEGIN                                                                           
  x:=0;                                                                         
  ok:=FALSE;                                                                    
  sign:=s[0]="-";                                                               
  i:=ORD(sign);                                                                 
  LOOP                                                                          
    IF i>HIGH(s) THEN EXIT END;                                                 
    IF s[i]<"0" THEN ok:=ok & (s[i]=0C); EXIT END;                              
    IF (s[i]<="9") & ((ORD(s[i])-48)<Base) THEN                                 
      x:=x*VAL(INTEGER, Base)+VAL(INTEGER, (ORD(s[i])-ORD("0"))); ok:=TRUE                
    ELSIF (s[i]>="A") & ((ORD(s[i])-55)<Base) THEN                              
      x:=x*VAL(INTEGER, Base)+VAL(INTEGER, ORD(s[i])-55);                                 
      ok:=TRUE;                                                                 
    ELSE ok:=FALSE; EXIT END;                                                   
    INC(i);                                                                     
  END;                                                                          
  IF sign THEN x:=-x END;                                                       
  RETURN ok;                                                                    
END StrToBased;                                                                 

PROCEDURE CardToStr(x,f:CARDINAL; VAR s:ARRAY OF CHAR);                         
VAR i,j:CARDINAL;                                                               
BEGIN                                                                           
  s[HIGH(s)]:=0C;                                                               
  i:=HIGH(s);                                                                   
  REPEAT                                                                        
    DEC(i);                                                                     
    s[i]:=CHR(x MOD 10+ORD("0"));                                               
    x:=x DIV 10;                                                                
  UNTIL (x=0) OR (i=0);                                                         
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;                                 
  WHILE i>f DO                                                                  
    DEC(i);                                                                     
    s[i]:=" ";                                                                  
  END;                                                                          
  IF i>0 THEN                                                                   
    j:=0;                                                                       
    WHILE i<=HIGH(s) DO                                                         
      s[j]:=s[i];                                                               
      INC(j);                                                                   
      INC(i);                                                                   
    END;                                                                        
  END;                                                                          
END CardToStr;                                                                  
                                                                                
PROCEDURE IntToStr(x:INTEGER; f:CARDINAL; VAR s:ARRAY OF CHAR);                 
VAR i,j:CARDINAL;                                                               
    neg:BOOLEAN;                                                                
BEGIN                                                                           
  s[HIGH(s)]:=0C;                                                               
  i:=HIGH(s);                                                                   
  IF x<0 THEN x:=-x; neg:=TRUE ELSE neg:=FALSE END;                             
  REPEAT                                                                        
    DEC(i);                                                                     
    s[i]:=CHR(x MOD 10+ORD("0"));                                               
    x:=VAL(CARDINAL, x) DIV 10;                                                      
  UNTIL (x=0) OR (i=0);                                                         
  IF neg & (i>0) THEN DEC(i); s[i]:="-" END;                                    
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;                                 
  WHILE i>f DO                                                                  
    DEC(i);                                                                     
    s[i]:=" ";                                                                  
  END;                                                                          
  IF i>0 THEN                                                                   
    j:=0;                                                                       
    WHILE i<=HIGH(s) DO                                                         
      s[j]:=s[i];                                                               
      INC(j);                                                                   
      INC(i);                                                                   
    END;                                                                        
  END;                                                                          
END IntToStr;                                                                   

PROCEDURE MakeTime(time:CARDINAL; VAR tstr:ARRAY OF CHAR);                      
VAR mon, year, day, monthlen:CARDINAL;                                          
    k:ARRAY[0..12] OF CHAR;                                                     
                                                                                
PROCEDURE tostr(n:CARDINAL;s:ARRAY OF CHAR);                                    
VAR h:ARRAY[0..1] OF CHAR;                                                      
BEGIN                                                                           
  h[1]:=0C;                                                                     
  h[0]:=CHR(ORD('0')+n DIV 10);                                                 
  Append(tstr,h);                                                               
  h[0]:=CHR(ORD('0')+n MOD 10);                                                 
  Append(tstr,h);                                                               
  Append(tstr,s);                                                               
END tostr;                                                                      
                                                                                
BEGIN                                                                           
  tstr[0]:=0C;                                                                  
  day:=25567+time DIV (60*60*24);                                               
  IF day>=36584 THEN INC(day) END;                                              
  year:=day*4 DIV 1461;                                                         
  day:=1 + day*4 MOD 1461 DIV 4;                                                
  mon:=0;                                                                       
  k[0]:=0C;                                                                     
  Append(k,'3303232332323');                                                    
  IF year MOD 4 = 0 THEN k[2]:='1' END;                                         
  LOOP                                                                          
    INC(mon);                                                                   
    monthlen:=ORD(k[mon])-20;                                                   
    IF day<=monthlen THEN EXIT END;                                             
    DEC(day, monthlen);                                                         
  END;                                                                          
  monthlen:=ORD(k[mon-1])-20;                                                   
  tostr(19+year DIV 100,'');                                                    
  tostr(year MOD 100,'.');                                                      
  tostr(mon,'.');                                                               
  tostr(day,' ');                                                               
  tostr(time DIV (60*60) MOD 24,':');                                           
  tostr(time DIV 60 MOD 60,':');                                                
  tostr(time MOD 60,'');                                                        
END MakeTime;                                                                   


END Str.
