<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*+PROCINLINE*>
<*+NOPTRALIAS*>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKSET*>
<*CPU="PENTIUM"*>

MODULE udpbox; (* axudp in/out ui/aprs stream splitter by OE5DXL *)

IMPORT FIO, IO, Str, udp;
FROM FdSet IMPORT FdSet, TimeVal, FD_ZERO, FD_SET, FD_ISSET;
FROM mlib IMPORT select;
FROM SYSTEM IMPORT CAST, SHIFT, ADR, CARD8;
FROM Storage IMPORT ALLOCATE;
FROM Lib IMPORT NextArg;

TYPE  UDPPORT=CARDINAL;
      IPNUM=CARDINAL;
      SET8=SET OF [0..7];
      FILTTYP=CHAR;
      SET256=SET OF [0..255];
    
      pOUTPORT=POINTER TO OUTPORT;
      OUTPORT=RECORD
                next     : pOUTPORT;
                toip     : IPNUM;   
                toport   : UDPPORT;
                filter   : FILTTYP;
                rawwrite : BOOLEAN;
                aprspass : SET256;
              END;
      
      pINSOCK=POINTER TO INSOCK;
      INSOCK=RECORD
               next    : pINSOCK;
               fd      : INTEGER;
               rawread : BOOLEAN;
               fromip  : IPNUM;
               bindport: UDPPORT;
               outchain: pOUTPORT;
             END; 

CONST MAXLEN=256+7*9+20+2;
      MINLEN=7*2+1+2;
      POLYNOM=BITSET{3,10,15};
      CRCINIT=BITSET{0..15};
      CRCRESULT=BITSET(40715);
      cFILTPASSALL="a";
      cFILTPASS="p";
      cFILTDEL="d";

VAR maxsock       : INTEGER;
    ibuf, rawbuf  : ARRAY[0..MAXLEN-1] OF CHAR;
    mbuf          : ARRAY[0..511] OF CHAR;
    CRCL, CRCH    : ARRAY[0..255] OF SET8;
    inlen, res    : INTEGER;
    monlen        : CARDINAL;
    rset, inset   : FdSet;
    converted, show : BOOLEAN;
    insocks, actsock : pINSOCK;
    outsock       : pOUTPORT;
    showip        : IPNUM;
    showport      : UDPPORT;

PROCEDURE Err(text:ARRAY OF CHAR);
BEGIN
  IO.WrStr(text); IO.WrStrLn(" error abort");
  HALT
END Err;


PROCEDURE Gencrctab;
CONST POLINOM=08408H;
VAR i,crc,c:CARDINAL;
BEGIN
  FOR c:=0 TO 255 DO
    crc:=255-c;
    FOR i:=0 TO 7 DO
      IF ODD(crc) THEN crc:=CAST(CARDINAL, CAST(BITSET, ASH(crc, -1))/CAST(BITSET,POLINOM))
      ELSE crc:=ASH(crc, -1) END;
    END;
    CRCL[c]:=CAST(SET8, crc);
    CRCH[c]:=CAST(SET8, 255 - ASH(crc, -8));
  END;
END Gencrctab;




PROCEDURE AppCRC(VAR frame:ARRAY OF CHAR; size:INTEGER);
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=0 TO size-1 DO
    b:=CAST(CARD8, CAST(SET8, frame[i]) / l);
    l:=CRCL[b] / h;
    h:=CRCH[b];
  END;
  frame[size  ]:=CAST(CHAR, l);
  frame[size+1]:=CAST(CHAR, h);
END AppCRC;


PROCEDURE Filter(VAR b:ARRAY OF CHAR; len:INTEGER; filt:FILTTYP; pass:SET256):BOOLEAN;
VAR i:INTEGER;
BEGIN
  IF filt=cFILTPASSALL THEN RETURN TRUE END;

  i:=13;
  WHILE (i<len) & NOT ODD(ORD(b[i])) DO INC(i, 7) END;
  IF CAST(SET8, b[i+1])-SET8{4}=SET8{0,1} THEN                              (* is UI frame *)
    INC(i,3);                                                               (* first data byte *)  
    IF (i<len) & (ORD(b[i]) IN pass) THEN RETURN TRUE END;
  END;
  RETURN FALSE;
END Filter; 



PROCEDURE getudp(fd:INTEGER; VAR buf:ARRAY OF CHAR; fromip:IPNUM; addcrc:BOOLEAN):INTEGER;
VAR fromport:UDPPORT;
    ip:IPNUM;
    crc1, crc2:CHAR;
    len:INTEGER;
BEGIN
  len:=udp.udpreceive(fd, buf, SIZE(buf), fromport, ip);
  IF (len>2) & (len<CAST(INTEGER, SIZE(buf))) & ((fromip=0) OR (fromip=ip)) THEN
    showip:=ip;
    showport:=fromport;
    IF NOT addcrc THEN RETURN len END;

    crc1:=buf[len-2];
    crc2:=buf[len-1];
    AppCRC(buf, len-2);
    IF (crc1=buf[len-2]) & (crc2=buf[len-1]) THEN RETURN len END; 

  END;
  RETURN -1
END getudp; 


PROCEDURE mon2raw(VAR mon, raw:ARRAY OF CHAR; VAR p:INTEGER);
CONST CTRL=CHR(3);
      PID=CHR(0F0H);
      cTO=">"; 
      cVIA=",";
      cLASTCALL=":";
      cSSID="-";
      cREPEATED="*";
      MAXVIAS=7;
      MAXSSID=15;
      SSIDBASE=16*3;
      CALLLEN=7;
      CALLFILL=" ";
      
VAR i,n,r:CARDINAL;
    

PROCEDURE call(sep1, sep2, sep3:CHAR; sbase:CARDINAL):BOOLEAN;
VAR l,s:CARDINAL; 
BEGIN
  l:=0;
  WHILE (mon[i]<>0C) & (mon[i]<>sep1) & (mon[i]<>sep2) & (mon[i]<>sep3) & (mon[i]<>cSSID) DO
    raw[p]:=CHR(ORD(mon[i])*2 MOD 256);
    INC(p);
    INC(i);
    INC(l);
    IF l>=CALLLEN THEN RETURN FALSE END;
  END;
  WHILE l<CALLLEN-1 DO
    raw[p]:=CHR(ORD(CALLFILL)*2);
    INC(p);
    INC(l);
  END;
  s:=0;
  IF mon[i]=cSSID THEN
    INC(i);
    WHILE (mon[i]>="0") & (mon[i]<="9") DO s:=s*10 + ORD(mon[i])-ORD("0"); INC(i) END;
    IF s>MAXSSID THEN RETURN FALSE END;    
  END;
  raw[p]:=CHR((s+sbase)*2);
  INC(p);
  RETURN TRUE
END call;

BEGIN
  p:=CALLLEN;
  i:=0;
  IF NOT call(cTO, 0C, 0C, SSIDBASE) THEN p:=0; RETURN END;            (* from call *)

  p:=0;
  IF mon[i]<>cTO THEN RETURN END;                                      (* ">" *)

  INC(i);
  IF NOT call(cLASTCALL, cVIA, 0C, SSIDBASE+64) THEN p:=0; RETURN END; (* dest call bit 7 for UI v2 command *)

  p:=CALLLEN*2;
  n:=0;
  WHILE mon[i]=cVIA DO
    INC(i);
    IF NOT call(cLASTCALL, cVIA, cREPEATED, SSIDBASE) THEN p:=0; RETURN END; 

    INC(n);
    IF n>MAXVIAS THEN p:=0; RETURN END;

    IF mon[i]=cREPEATED THEN                                           (* "*" has repeatet sign *)
      INC(i);
      FOR r:=p TO CALLLEN*3 BY -CALLLEN DO raw[r-1]:=CHR(ORD(raw[r-1])+128) END; (* set "has repeated" flags *)
    END;
  END;
  IF (p=0) OR (mon[i]<>cLASTCALL) THEN p:=0; RETURN END;               (* ":" start of info sign *)

  raw[p-1]:=CHR(ORD(raw[p-1]) + 1);                                    (* end address field mark *)
  raw[p]:=CTRL;
  INC(p);
  raw[p]:=PID;
  INC(p);
  INC(i);
  WHILE (mon[i]<>0C) & (i<=HIGH(mon)) DO                               (* copy info part *)
    IF p>=VAL(INTEGER, HIGH(raw))-2 THEN p:=0; RETURN END;             (* spare 2 bytes for crc *)

    raw[p]:=mon[i];
    INC(p);
    INC(i);
  END;
  AppCRC(raw,p); 
  INC(p, 2);
END mon2raw;



PROCEDURE raw2mon(VAR raw, mon:ARRAY OF CHAR; len:CARDINAL; VAR p:CARDINAL);
VAR i:CARDINAL;


  PROCEDURE Call(pos:CARDINAL);
  VAR i,e,ssid:CARDINAL;
  BEGIN
    e:=pos;
    FOR i:=pos TO pos+5 DO 
      IF raw[i]<>100C THEN e:=i END;
    END; 
    FOR i:=pos TO e DO mon[p]:=CHR(ASH(ORD(raw[i]), -1)); INC(p); END;
    ssid:=ASH(ORD(raw[pos+6]), -1) MOD 16;
    IF ssid>0 THEN 
      mon[p]:="-"; INC(p); 
      IF ssid>9 THEN mon[p]:="1"; INC(p); END;
      mon[p]:=CHR(ssid MOD 10 + ORD("0")); INC(p);
    END;
  END Call;

BEGIN
  p:=0;
  mon[p]:=0C;
  i:=0;
  WHILE NOT ODD(ORD(raw[i])) DO 
    INC(i);
    IF i>len THEN RETURN END;           (* no address end mark found *)
  END;
  IF i MOD 7 <> 6 THEN RETURN END;      (* address end not modulo 7 error *)

  Call(7);
  mon[p]:=">"; INC(p);
  Call(0);

  i:=14;
  WHILE (i+6<len) & NOT ODD(ORD(raw[i-1])) DO
    mon[p]:=","; INC(p);
    Call(i);
    IF (ORD(raw[i+6])>=128) & (ODD(ORD(raw[i+6])) OR (ORD(raw[i+13])<128)) 
    THEN mon[p]:="*"; INC(p); END;
    INC(i,7);
  END;  
  INC(i,2);  (* ctrl, pid *)

  mon[p]:=":"; INC(p);

  WHILE (i<len) & (p<HIGH(mon)) DO 
    IF (*raw[i]>=" "*) raw[i]<>0C THEN mon[p]:=raw[i]; INC(p); END; 
    INC(i);
  END;
(*
  mon[p]:=15C; INC(p);
  mon[p]:=12C; INC(p);
*)
  mon[p]:=0C; INC(p);

  mon[p]:=0C;

END raw2mon;

PROCEDURE GetIp(h:ARRAY OF CHAR; VAR ip:IPNUM; VAR port:UDPPORT):INTEGER;
VAR i, p, n:CARDINAL;
    ok:BOOLEAN;
BEGIN
  p:=0;
  h[HIGH(h)]:=0C;
  ip:=0;
  n:=0;
  FOR i:=0 TO 4 DO
    n:=0;
    ok:=FALSE;
    WHILE (h[p]>="0") & (h[p]<="9") DO
      ok:=TRUE;
      n:=n*10+ORD(h[p])-ORD("0");
      INC(p);
    END;
    IF NOT ok THEN RETURN -1 END;
    IF i<3 THEN
      IF (h[p]<>".") OR (n>255) THEN RETURN -1 END;

      ip:=ip*256+n;
    ELSIF i=3 THEN
      ip:=ip*256+n;
      IF (h[p]<>":") OR (n>255) THEN RETURN -1 END;

    ELSIF n>65535 THEN RETURN -1 END;

    port:=n;
    INC(p);
  END;  
  RETURN 0
END GetIp;


PROCEDURE parms;
VAR h                : ARRAY[0..4095] OF CHAR;
    err              : BOOLEAN;
    lasth            : CHAR;
    actsock          : pINSOCK;
    actfilt          : FILTTYP;
    actpass          : SET256;
    i, n             : CARDINAL;
BEGIN
  actsock:=NIL;
  err:=FALSE;
  show:=FALSE;
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN
      lasth:=h[1];
      IF (lasth="R") OR (lasth="M") THEN
        NextArg(h);
        actfilt:=cFILTPASSALL;
        actpass:=SET256{0..255};
        ALLOCATE(actsock, SIZE(actsock^));
        IF actsock=NIL THEN Err("out of memory") END;
        WITH actsock^ DO
          IF GetIp(h, fromip, bindport)<0 THEN Err("cannot open udp socket") END;
          fd:=udp.openudp();
          rawread:=lasth="R";
          outchain:=NIL;
          IF (fd>=0) & (udp.bindudp(fd, bindport)<0) THEN Err("cannot bind inport") END;
        END;
        IF insocks=NIL THEN insocks:=actsock; actsock^.next:=NIL;
        ELSE actsock^.next:=insocks; insocks:=actsock END;
      
      ELSIF lasth="f" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -f") END;
        actpass:=SET256{};
        actfilt:=h[0];
        IF actfilt<>cFILTPASSALL THEN
          i:=1;
          n:=0;
          LOOP
            IF i>=HIGH(h) THEN EXIT END;
            IF (h[i]>="0") & (h[i]<="9") THEN n:=n*10 + ORD(h[i]) - ORD("0");
            ELSE
              IF (n>0) & (n<256) THEN INCL(actpass, n) END;
              n:=0;
              IF h[i]<>"," THEN EXIT END;
            END;  
            INC(i);
          END;
          IF actfilt=cFILTDEL THEN actpass:=-actpass END;  
        END;

      ELSIF (lasth="r") OR (lasth="m") THEN
        IF actsock=NIL THEN Err("need input -M or -R before -r or -m") END;
        NextArg(h);

        ALLOCATE(outsock, SIZE(outsock^));
        IF outsock=NIL THEN Err("out of memory") END;
        WITH outsock^ DO
          IF GetIp(h, toip, toport)<0 THEN Err("wrong udp:port") END;
          filter:=actfilt;
          aprspass:=actpass;
          rawwrite:=lasth="r";
        END;
        IF actsock^.outchain=NIL THEN actsock^.outchain:=outsock; outsock^.next:=NIL;
        ELSE outsock^.next:=actsock^.outchain; actsock^.outchain:=outsock END;

      ELSIF lasth="h" THEN
        IO.WrStrLn(" -R <ip:port>   read raw axudp frame, 0 ip read from all (-R 0.0.0.0:2000)");
        IO.WrStrLn(" -M <ip:port>   read aprs monitor udp frame");
        IO.WrStrLn(" -f <filterparm>  filter frame 'a' all passes (-f a)");
        IO.WrStrLn("                  'p<x>,<x>...' pass UI frames with first char in set (-f p58,110)");
        IO.WrStrLn("                  'd<x>,<x>...' pass UI frames with not first char in set (-f d58)");
        IO.WrStrLn(" -m <ip:port>   send aprs monitor udp frame");
        IO.WrStrLn(" -r <ip:port>   send aprs raw axudp frame");
        IO.WrStrLn(" -v             show frames on stdout");

        HALT

      ELSIF lasth="v" THEN
        show:=TRUE;
 
      ELSE err:=TRUE END;
      h[0]:=0C;
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN IO.WrStr(">"); IO.WrStr(h); IO.WrStrLn("< use -h"); HALT END;

END parms;

PROCEDURE showpip(ip:IPNUM; port:UDPPORT);
BEGIN
  IO.WrCard(ip DIV 1000000H,1); IO.WrChar(".");
  IO.WrCard(ip DIV 10000H MOD 100H ,1); IO.WrChar(".");
  IO.WrCard(ip DIV 100H MOD 100H ,1); IO.WrChar(".");
  IO.WrCard(ip MOD 100H ,1); IO.WrChar(":");
  IO.WrCard(port, 1);
END showpip;

PROCEDURE showstr(s:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) DO
    IF s[i]<" " THEN s[i]:="." END;
    INC(i);
  END;
  IO.WrStrLn(s); 
END showstr;

BEGIN
  insocks:=NIL;
  Gencrctab;
  parms;


  FD_ZERO(inset);
  maxsock:=0;
  actsock:=insocks;
  WHILE actsock<>NIL DO
    WITH actsock^ DO  
      IF fd>=0 THEN 
        FD_SET(fd, inset);
        IF fd>maxsock THEN maxsock:=fd END; 
      END;
      actsock:=next;
    END;
  END;

  LOOP
    rset:=inset;
    IF select(maxsock+1, ADR(rset), NIL, NIL, NIL)>=1 THEN
      actsock:=insocks;
      WHILE actsock<>NIL DO  
        IF (actsock^.fd>=0) & FD_ISSET(actsock^.fd, rset) THEN
          inlen:=getudp(actsock^.fd, ibuf, actsock^.fromip, actsock^.rawread);
          IF inlen>0 THEN
            IF actsock^.rawread THEN rawbuf:=ibuf 
            ELSE 
              IF inlen<=HIGH(ibuf) THEN ibuf[inlen]:=0C END; 
              mon2raw(ibuf, rawbuf, inlen);
            END;

            IF inlen>=2 THEN
              converted:=FALSE;
              IF show THEN
                raw2mon(rawbuf, mbuf, inlen-2, monlen);
                converted:=TRUE;
                showpip(showip, showport);
                IO.WrChar(":");
                showstr(mbuf);
              END;

              outsock:=actsock^.outchain;
              WHILE outsock<>NIL DO
                IF show THEN IO.WrStr(" tx: "); showpip(outsock^.toip, outsock^.toport); END;
                IF Filter(rawbuf, inlen, outsock^.filter, outsock^.aprspass) THEN
                  IF NOT (outsock^.rawwrite OR converted) THEN
                    raw2mon(rawbuf, mbuf, inlen-2, monlen);              
                    converted:=TRUE;
                  END;
                  IF outsock^.rawwrite THEN
                    res:=udp.udpsend(actsock^.fd, rawbuf, inlen, outsock^.toport, outsock^.toip);
                    IF show THEN IO.WrStrLn(" raw") END;
                  ELSIF monlen>0 THEN
                    res:=udp.udpsend(actsock^.fd, mbuf, monlen, outsock^.toport, outsock^.toip);
                    IF show THEN IO.WrStrLn(" mon") END;
                  END;
                ELSIF show THEN IO.WrStrLn(" deleted") END;
                outsock:=outsock^.next;
              END;
            ELSIF show THEN IO.WrStrLn("bad mon format "); END;
          END;  
        END;
        actsock:=actsock^.next;
      END;
    END;
  END;
END udpbox.


(*
OE7XGR>APU25N,OE5XOR*:=4703.81NL01140.78E#Hintertuxer Gletscher Digi Igate 3250m


0:fm OE6XLR-11 to APNU19-1 via DB0HOB* ctl UIv1 pid F0 q:86 -26.5dB
!4721.50NW01511.27E#PHG3937 W3,Hohe Mugel JN77OI WIDEn-N

0000  82 a0 9c aa 62 72 62 9e  8a 6c b0 98 a4 76 88 84  . .brb. .l.v..
                        ==                    ==                 
0010  60 90 9e 84 e1 03 f0 21  34 37 32 31 2e 35 30 4e  ....! 4721.50N
                  ==
0020  57 30 31 35 31 31 2e 32  37 45 23 50 48 47 33 39  W01511.2 7E#PHG39
0030  33 37 20 57 33 2c 48 6f  68 65 20 4d 75 67 65 6c  37 W3,Ho he Mugel
0040  20 4a 4e 37 37 4f 49 20  57 49 44 45 6e 2d 4e 20   JN77OI  WIDEn-N
-r 0.0.0.0:9301 -f u -M 192.168.1.30:9401 -f a -R 192.168.1.30:19401
*)